// LocalProxy.cpp : ܼ  α׷   մϴ.
//

#ifdef _WIN32
# define _CRT_SECURE_NO_WARNINGS
#endif

#include "CRXSocket.h"
#include "CRXProxy.h"

#include <iostream>
#include <iomanip>
#include <sstream>

#include <stdio.h>
#include <string.h>

using namespace std;

int main (int argc, char* argv[])
{
	int						aResult	= 0;
	const unsigned short	aPort	= 8080;

	CRXSocket				aSocket;
	CRXProxy				* aProxy = NULL;

	/*----------------------------------------------------------------*/
	/*----------------------------------------------------------------
	 * Initialize
	 *----------------------------------------------------------------*/
	aResult = aSocket.CreateServer (aPort);
	if (aResult < 0)
	{
		cout << "Failed to create server." << endl;
		return aResult;
	}

	for (;;)
	{
		aResult = aSocket.Accept ();
		if (aResult < 0)
		{
			cout << "Failed to accept." << endl;
			break;
		}

		if ((aProxy = CRXProxy::GetNewInstance (aResult)) == NULL)
		{
			cout << "Failed to get proxy." << endl;
			aResult = -1;
			break;
		}

		aResult = aProxy->ForwardMT ();
		if (aResult < 0)
		{
			cout << "Failed to forward." << endl;
			break;
		}
	}

	/*----------------------------------------------------------------*/
	aSocket.Close ();

	return aResult;
}